> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/web/search/text-search.md).

# Search Text in PDF and Office Documents using JavaScript

Discover how to search text in PDF documents efficiently using JavaScript. Learn about key functions like addSearchListener and searchTextFull. The Apryse Web SDK streamlines secure, serverless docume

## Search through the UI

WebViewer, DOCX Editor, and Spreadsheet Editor each have a text search panel built into the UI to handle searching in their respective file types.

![WebViewer Search UI](https://3532544125-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FX9YnTSKIHvV7m0A36LbO%2Fuploads%2Fgit-blob-45b4ab5fe68827566f93674b65ebc6a43d324edb%2Fa7c403269187030844003420f408ec0bd2efa7bf-1239x607.png?alt=media)

## Search programmatically

Searching for text can be performed using programmatic APIs:

{% tabs %}
{% tab title="JavaScript" %}
{% code lineNumbers="true" %}

```js
WebViewer(...)
.then(instance => {
  const documentViewer = instance.Core.documentViewer;
  
  documentViewer.addEventListener('documentLoaded', async () => {
    const searchStream = documentViewer.search('search_term'); // Setting up stream using your string to search.
    const searchResults = await searchStream.getAll(); // Wait for all results.
    console.log('search results:', searchResults);
  });
});
```

{% endcode %}
{% endtab %}
{% endtabs %}

[DocumentViewer.search](https://sdk.apryse.com/api/web/Core.DocumentViewer.html#search)

For more precise results, you can add [Search.Mode](https://sdk.apryse.com/api/web/Core.Search.html#.Mode__anchor) options to better refine the results:

{% tabs %}
{% tab title="JavaScript" %}
{% code lineNumbers="true" %}

```js
WebViewer(...)
.then(instance => {
  const { documentViewer, Search } = instance.Core;
  
  documentViewer.addEventListener('documentLoaded', async () => {
    const searchMode = [Search.Mode['WHOLE_WORD'], Search.Mode['CASE_SENSITIVE']];
    const searchStream = documentViewer.search('search_term', searchMode); // Setting up stream using your string to search with whole word and case sensitivity.
    const searchResults = await searchStream.getAll(); // Wait for all results.
    console.log('search results:', searchResults);
  });
});
```

{% endcode %}
{% endtab %}
{% endtabs %}

[DocumentViewer.search](https://sdk.apryse.com/api/web/Core.DocumentViewer.html#search)

You can also progressively search for text if you don’t want to wait for the entire list of search items to be retrieved:

{% tabs %}
{% tab title="JavaScript" %}
{% code lineNumbers="true" %}

```js
WebViewer(...)
.then(instance => {
  const documentViewer = instance.Core.documentViewer;
  
  documentViewer.addEventListener('documentLoaded', async () => {
    const searchStream = documentViewer.search('search_term'); // Setting up stream using your string to search.
    const searchResults= [];
  
    for await (const result of searchStream) {
      searchResults.push (result); // Progressively adding results to an array.
      console.log('search result found:', result);
    }
  });
});
```

{% endcode %}
{% endtab %}
{% endtabs %}

[DocumentViewer.search](https://sdk.apryse.com/api/web/Core.DocumentViewer.html#search)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.apryse.com/web/search/text-search.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
